﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports System.Collections.Generic


Public Class ProductManagerDB

  Private Const productList As String = "ProductList"

  Public Shared Function GetProductList() As List(Of Product)
    Dim clsProductList As List(Of Product) = New List(Of Product)
    Dim clsProduct As Product
    Dim ds As New DataSet()
    Dim dt As DataTable

    If HttpContext.Current.Cache(productList) IsNot Nothing Then
      dt = CType(HttpContext.Current.Cache(productList), DataTable)
    Else
      ds.ReadXml(HttpContext.Current.Server.MapPath("~\App_Data\books.xml"))
      dt = ds.Tables(0)
      HttpContext.Current.Cache.Insert(productList, dt, Nothing, DateTime.Now.AddMinutes(20), TimeSpan.Zero)
    End If

    For Each dr As DataRow In dt.Rows
      clsProduct = New Product
      clsProduct.ID = dr("id")
      clsProduct.Title = dr("title")
      clsProduct.Description = dr("description")
      clsProduct.Price = dr("price")
      clsProduct.ImageLarge = dr("imageLarge")
      clsProduct.ImageMedium = dr("imageMedium")
      clsProduct.ImageSmall = dr("imageSmall")
      clsProductList.Add(clsProduct)
    Next

    Return clsProductList
  End Function

  Public Shared Function GetProduct(ByVal intProductID As Integer) As Product
    Dim ds As New DataSet()
    Dim dt As DataTable
    Dim clsProduct As Product = New Product()

    If HttpContext.Current.Cache(productList) IsNot Nothing Then
      dt = CType(HttpContext.Current.Cache(productList), DataTable)
    Else
      ds.ReadXml(HttpContext.Current.Server.MapPath("~\App_Data\books.xml"))
      dt = ds.Tables(0)
      HttpContext.Current.Cache.Insert(productList, dt, Nothing, DateTime.Now.AddMinutes(20), TimeSpan.Zero)
    End If

    Dim dv As DataView = dt.DefaultView
    dv.RowFilter = "ID=" & intProductID
    Dim drv As DataRowView = dv(0)

    clsProduct.ID = drv("id")
    clsProduct.Title = drv("title")
    clsProduct.Description = drv("description")
    clsProduct.Price = drv("price")
    clsProduct.ImageLarge = drv("imageLarge")
    clsProduct.ImageMedium = drv("imageMedium")
    clsProduct.ImageSmall = drv("imageSmall")

    Return clsProduct

  End Function

End Class

